=== debian/changelog ===
xwrited (2-1build1) bionic; urgency=high

  * No change rebuild to pick up -fPIE compiler default

 -- Balint Reczey <rbalint@ubuntu.com>  Tue, 03 Apr 2018 12:53:24 +0000

xwrited (2-1) unstable; urgency=low

  * Initial release. Closes: #780525

 -- Thomas Koch <thomas@koch.ro>  Tue, 11 Aug 2015 12:12:15 +0200
