=== debian/control ===
Source: xwrited
Section: x11
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Thomas Koch <thomas@koch.ro>
Build-Depends: debhelper (>= 9),
 docbook-xsl,
 docbook-xsl-ns,
 intltool,
 libdbus-glib-1-dev,
 libglib2.0-dev,
 libnotify-dev,
 libutempter-dev,
 xsltproc,
Standards-Version: 3.9.6
Homepage: https://code.guido-berhoerster.org/projects/xwrited/
Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/xwrited.git/
Vcs-Git: git://anonscm.debian.org/collab-maint/xwrited.git

Package: xwrited
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: display write and wall messages as desktop notifications
 The xwrited utility displays write(1) and wall(1) messages as desktop
 notifications. A notification daemon compliant to the freedesktop.org
 Desktop Notification Specification draft needs to be running in order
 to display the notifications.
 .
 This utility is useful e.g. to send (forward) broadcast (wall) messages
 to all users from cronjobs or system daemons.
 .
 The xwrited daemon is automatically started for each new X session
 after the installation of this package.
