=== debian/changelog ===
xwrited (3-2build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:40:25 +1100

xwrited (3-2build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 08:19:31 +0000

xwrited (3-2) unstable; urgency=medium

  * QA upload.
  * Using new DH level format. Consequently:
       - debian/compat: removed.
       - debian/control: changed from 'debhelper' to 'debhelper-compat' in
         Build-Depends field and bumped level to 13.
  * debian/control: bumped Standards-Version to 4.6.2.
  * debian/watch: update watch file version '3' to '4'.

 -- Aquila Macedo Costa <aquilamacedo@riseup.net>  Tue, 20 Jun 2023 10:58:17 -0300

xwrited (3-1) unstable; urgency=medium

  * new upstream version 3
  * fix Vcs-* tags in d/control (alioth->salsa)
  * update debian-policy 3.9.6->4.1.5, no changes
  * update debhelper version 9->11
  * rm patch correct_command_name_in_manpage, fixed upstream
  * rm patch respect_CPPFLAGS_from_environment

 -- Thomas Koch <thomas@koch.ro>  Sun, 29 Jul 2018 19:55:51 +0000
