=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: x11
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Thomas Koch <thomas@koch.ro>
-Build-Depends: debhelper (>= 9),
+XSBC-Original-Maintainer: Debian QA Group <packages@qa.debian.org>
+Build-Depends: debhelper-compat (= 13),
  docbook-xsl,
  docbook-xsl-ns,
  intltool,
@@ -12,10 +12,10 @@
  libnotify-dev,
  libutempter-dev,
  xsltproc,
-Standards-Version: 3.9.6
+Standards-Version: 4.6.2
 Homepage: https://code.guido-berhoerster.org/projects/xwrited/
-Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/xwrited.git/
-Vcs-Git: git://anonscm.debian.org/collab-maint/xwrited.git
+Vcs-Browser: https://salsa.debian.org/debian/xwrited
+Vcs-Git: https://salsa.debian.org/debian/xwrited.git
 
 Package: xwrited
 Architecture: any
