=== debian/watch ===
### watch control file for uscan
### See uscan(1) for how to set this file properly
###  * uupdate(1) for upgrade a source code package
###  * gbp-import-orig(1) with --uscan for upgrade GIT repo
version=4
https://code.guido-berhoerster.org/projects/xwrited/ ./downloads/xwrited-(.*)\.(?:tar.gz|tar.bz2|tar.xz)
